unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, upfManager, ComCtrls, TabsheetCoreUnit;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    PageControl1: TPageControl;
    upfPluginManager1: TupfPluginManager;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure upfPluginManager1PluginRegistered(Sender, APlugin: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddTabsheet(ACaption :  string; AFrame : TFrame); 
  end;

var
  Form1: TForm1;

implementation

uses TestFrame;

{$R *.dfm}

procedure TForm1.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
   ShowMessage('TMS Plugin Framework Tabsheet Demo'#13#10'Copyright  2003-2004, TMS software');
end;

procedure TForm1.AddTabsheet(ACaption : string; AFrame : TFrame);
var
   ATabSheet : TTabSheet;
begin
  ATabsheet := TTabSheet.Create(PageControl1);
  ATabsheet.PageControl := PageControl1;
  ATabsheet.Caption := ACaption;
  AFrame.Parent := ATabsheet;
  AFrame.Align := alClient;
end;

procedure TForm1.upfPluginManager1PluginRegistered(Sender,
  APlugin: TObject);
var
  ATabSheetPlugin : ITabSheetPlugin;
begin
  // Check to see if this plugin is a Tabsheet Plugin.
  // If so, create a tabsheet and place the plugin's frame
  // into it!
  if Supports(APlugin, ITabsheetPlugin, ATabSheetPlugin) then
  begin
    AddTabSheet(ATabsheetPlugin.Caption, ATabsheetPlugin.Frame);
    ATabSheetPlugin := nil;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   AddTabsheet('A Frame', TFrame1.Create(nil));
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  upfPluginManager1.PluginFolder := ExtractFilePath(Application.ExeName);
  upfPluginManager1.LoadPlugin(ExtractFilePath(Application.ExeName) + '\tabsheetpluginone.bpl');
//  upfPluginManager1.LoadPlugins;
end;

end.
